//+------------------------------------------------------------------+
//|                                                       TMA V2.mq4 |
//|                                     Copyright 2014, balachandran |
//|                                            bala100gain@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, balachandran"
#property link      "bala100gain@gmail.com"

#property indicator_chart_window
#property indicator_buffers    3

#property indicator_color2     Red
#property indicator_color3     Lime
#property indicator_style2     STYLE_SOLID
#property indicator_style3     STYLE_SOLID

extern string TimeFrame       = "";
extern int    HalfLength      = 56;
extern int    Price           = PRICE_CLOSE;
extern double ATRMultiplier   = 2.0;
extern int    ATRPeriod       = 100;
extern bool   Interpolate     = true;

double buffer1[];
double buffer2[];
double buffer3[];


int    timeFrame,tt;

int init()
  {
IndicatorBuffers(3);
   HalfLength=MathMax(HalfLength,1);
      SetIndexBuffer(0,buffer1); SetIndexDrawBegin(0,HalfLength);
      SetIndexBuffer(1,buffer2); SetIndexDrawBegin(1,HalfLength);
      SetIndexBuffer(2,buffer3); SetIndexDrawBegin(2,HalfLength);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int counted_bars=IndicatorCounted();
   int i,j,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars+HalfLength);
          int tf= stringToTimeFrame(TimeFrame);
           
            for (i=limit; i>=0; i--)
      {
         double sum  = (HalfLength+1)*iMA(NULL,tf,1,0,MODE_LWMA,Price,i);
         double sumw = (HalfLength+1);
         
         for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
         {
            sum  += k*iMA(NULL,tf,1,0,MODE_LWMA,Price,i+j);
            sumw += k;

            if (j<=i)
            {
               sum  += k*iMA(NULL,tf,1,0,MODE_LWMA,Price,i-j);
               sumw += k;
            }
         }

             
         double range = iATR(NULL,tf,ATRPeriod,i+10)*ATRMultiplier;
            buffer1[i] = sum/sumw;
            buffer2[i] = buffer1[i]+range;
            buffer3[i] = buffer1[i]-range;
            }
   return(0);
  }


string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   tfs = (tfs);
   if(tfs=="M1")
   {
   tt=1;
   }
    if(tfs=="M5")
   {
   tt=5;
   }
     
      if(tfs=="M15")
   {
   tt=15;
   }
     
      if(tfs=="M30")
   {
   tt=30;
   }
     
      if(tfs=="H1")
   {
   tt=60;
   }
     
      if(tfs=="H4")
   {
   tt=240;
   }
    if(tfs=="D1")
   {
   tt=1440;
   }
     
      if(tfs=="W1")
   {
   tt=10080;
   }
     
      if(tfs=="MN")
   {
   tt=43200;
   }
     
     
                                                      return(tt);
}
